/* m_linkctl.c -- adjust settings for the active link
 * Copyright (C) 2001-2002, ForestNet IRC Network
 * This is a free software; see file `license' for details.
 */

#ifndef lint
static char rcsid[] = "$Id: m_linkctl.c,v 1.6 2002/06/14 08:19:11 hex Exp $";
#endif

#include "struct.h"
#include "send.h"
#include "zlink.h"

int m_linkctl(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
	if (check_registered(sptr) || IsClient(sptr))
		return 0;

	if (parc > 1 && strcasecmp(parv[1], "+ZIP") == 0) {
		SetZipIn(sptr);
		if ((sptr->serv->zip_in = zip_create_input_session()) == NULL) {
			sendto_one(cptr, "ERROR :Incoming compressed link "
				"initialization failed.");
			return 0;
		}

		if (!ZipOut(cptr)) {
			sendto_one(cptr, "LINKCTL +ZIP");
			SetZipOut(cptr);
			if ((cptr->serv->zip_out = zip_create_output_session()) == NULL) {
				sendto_one(cptr, "ERROR :Outgoing compressed link initialization failed.");
				return 0;
			}
		}

		return ZIP_NEXT_BUFFER;
	}

	return 0;
}
